@echo off
setlocal
set rom=Game.sfc
set objs=
if not exist objs mkdir objs
del /Q *.lst
goto :main

:assemble
echo Assembling... %1.asm
ca65.exe -l %1.lst %1.asm -o objs\%1.obj
if %errorlevel% equ 0 set objs=%objs% objs\%1.obj
goto :eof

:link
echo Linking...
ld65.exe -o %rom% -m map.txt -C lorom256k.cfg %objs%
echo.
echo Finished linking. Please take note of any warnings/errors above.
goto :eof

:failure
echo Assembler or linker failed; see above output for details.
endlocal
exit /b %errorlevel%
goto :eof

:main
call :assemble Header           || goto failure
call :assemble 2input           || goto failuer
call :assemble LoadGraphics     || goto failure
call :assemble Metasprite       || goto failure
call :assemble ProcessOam       || goto failure
call :assemble Objects          || goto failure
call :assemble Game             || goto failure
call :link                      || goto failure

REM If things were successful, we'll have an .SFC file
if exist %rom% (
  echo.
  echo Results:
  dir %rom%
)
endlocal
